#include "simpletools.h"  

// The scale
const int ScaleButtonPin = 3; 
const int NumScales = 6;
volatile int currentScale = 0;

// The note
const int NoteButtonPin = 2; 
const int NumNotes = 12;
volatile int currentNote = 0;  
 
// The octave
const int OctaveButtonPin = 1; 
const int NumOctaves = 10;
volatile int currentOctave = 4;


volatile int refreshTuning = 0;  

const char* chromaticSharps[] = {"C","C#","D","D#","E","F","F#","G","G#","A","A#","B"};

void getButtons();                      


int main()                                    
{
  // Add startup code here.

  cog_run(getButtons, 128);
 
  while(1)
  {
    // Add main loop code here.
    if(refreshTuning == 1){
      refreshTuning = 0;
      term_cmd(CLS);
      print("Scale = %d\n", currentScale);
      print("Note = %s\n", chromaticSharps[currentNote]);
      print("Octave = %d\n", currentOctave);
    }      
    
  }  
}

void getButtons(){
  // Increment the following circular counters on a positive edge.
  // currentOctave (0..9)
  // currentScale (0..6)
  // currentNote (0..11)
  while(1)                                  
  {
    // The octave button
    if (input(OctaveButtonPin) > 0){ 
      currentOctave = (++currentOctave) % NumOctaves;
      refreshTuning = 1;
      pause(500);
    }     
    
    // The scale button
    if (input(ScaleButtonPin) > 0){ 
      currentScale = (++currentScale) % NumScales;
      refreshTuning = 1;
      pause(500);
    }     
    
    // The note button
    if (input(NoteButtonPin) > 0){ 
      currentNote = (++currentNote) % NumNotes;
      refreshTuning = 1;
      pause(500);
    }                                                          
  }
}