/*
  Jim Arlow, 2020
  
  Test program for LASERVox LCD.
*/

#include "simpletools.h"

serial *lcd;

const int ON  = 22;
const int CLR = 12;
const int LINE1 = 128;
const int LINE2 = 148;
const int LINE3 = 168;
const int LINE4 = 188;
const int BACKLIGHT_ON = 17;
const int BACKLIGHT_OFF = 18;

int main()
{
  lcd = serial_open(24, 24, 0, 2400);
 
  // Send control characters to the LCD using writeChar(...).
  // There is a full list of control characters in the LCD datasheet.
  writeChar(lcd, ON);
  writeChar(lcd, CLR);
  writeChar(lcd, BACKLIGHT_ON);

  pause(5);
  dprint(lcd, "Hello LCD!!!");
  
  writeChar(lcd, LINE2);
  dprint(lcd, "This is line 2");
  
  writeChar(lcd, LINE3);
  dprint(lcd, "This is line 3");
  
  writeChar(lcd, LINE4);
  dprint(lcd, "This is line 4");
}
