/*
  Blank Simple Project.c
  http://learn.parallax.com/propeller-c-tutorials 
*/
#include "simpletools.h"  
#include "ws2812.h"       

#define LEDS_PIN 25 
#define NUM_LEDS 48   

int LEDLock;
 
ws2812 *leds;  
// Array of RGB values for each LED
int  ledsArray[] = {0,0,0,0,0,0,0,0,0,0,0,0,
                    0,0,0,0,0,0,0,0,0,0,0,0,
                    0,0,0,0,0,0,0,0,0,0,0,0,
                    0,0,0,0,0,0,0,0,0,0,0,0};


void updateLEDS();   

void redRingTest();
void blueRingTest();
void greenRingTest();
void yellowRingTest();

int main()                                    
{
  // LED interface for ws2812 smart LEDs
  leds = ws2812b_open();
                      
  
  LEDLock = locknew();
  
  cog_run(redRingTest,128);
  cog_run(blueRingTest,128);
  cog_run(greenRingTest,128);
  cog_run(yellowRingTest,128);
 
  while(1)
  {
    // Add main loop code here.
    
  }  
}

void updateLEDS(){
  lockset(LEDLock);
  ws2812_set(leds, LEDS_PIN, ledsArray, NUM_LEDS);
  lockclr(LEDLock);
}  

void redRingTest(){
  while(1){
    for(int i = 0; i < 24; i++){
      ledsArray[i] = COLOR_RED;
      updateLEDS();
      pause(200);
      ledsArray[i] = COLOR_BLACK;
      updateLEDS();
    }     
  }    
}  

void blueRingTest(){
  while(1){
    for(int i = 24; i < 48; i++){
      ledsArray[i] = COLOR_BLUE;
      updateLEDS();
      pause(100);
      ledsArray[i] = COLOR_BLACK;
      updateLEDS();
    }     
  }    
}  

void greenRingTest(){
  while(1){
    for(int i = 0; i < 48; i++){
      ledsArray[i] = COLOR_GREEN;
      updateLEDS();
      pause(50);
      ledsArray[i] = COLOR_BLACK;
      updateLEDS();
    }     
  }    
}  

void yellowRingTest(){
  while(1){
    for(int i = 47; i >= 0; i--){
      ledsArray[i] = COLOR_YELLOW;
      updateLEDS();
      pause(30);
      ledsArray[i] = COLOR_BLACK;
      updateLEDS();
    }     
  }    
}  