(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     70058,       1580]
NotebookOptionsPosition[     62455,       1441]
NotebookOutlinePosition[     62848,       1457]
CellTagsIndexPosition[     62805,       1454]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["LASERVox Scale calculator", "Title",
 CellChangeTimes->{{3.818404073823197*^9, 
  3.818404080222404*^9}},ExpressionUUID->"8aacb6be-e246-4e3a-a029-\
72b090992f38"],

Cell[BoxData[
 RowBox[{"ClearAll", "[", "\"\<Global`*\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.818404057488925*^9, 
  3.818404062767044*^9}},ExpressionUUID->"0009aed5-f18f-48da-96c5-\
e34180cba819"],

Cell[CellGroupData[{

Cell["Some constants", "Section",
 CellChangeTimes->{{3.816848161932116*^9, 3.8168481624434147`*^9}, {
  3.817028163264246*^9, 
  3.817028167136168*^9}},ExpressionUUID->"91db6aee-bcad-4fa8-aa61-\
cfbae2cd7061"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CMajor", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
    "\"\<C\>\"", ",", "\"\<D\>\"", ",", "\"\<E\>\"", ",", "\"\<F\>\"", ",", 
     "\"\<G\>\"", ",", "\"\<A\>\"", ",", "\"\<B\>\""}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CNaturalMinor", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
    "\"\<C\>\"", ",", "\"\<D\>\"", ",", "\"\<Eb\>\"", ",", "\"\<F\>\"", ",", 
     "\"\<G\>\"", ",", "\"\<Ab\>\"", ",", "\"\<Bb\>\""}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CHarmonicMinor", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
    "\"\<C\>\"", ",", "\"\<D\>\"", ",", "\"\<Eb\>\"", ",", "\"\<F\>\"", ",", 
     "\"\<G\>\"", ",", "\"\<Ab\>\"", ",", "\"\<B\>\""}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CMelodicMinorUp", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
    "\"\<C\>\"", ",", "\"\<D\>\"", ",", "\"\<Eb\>\"", ",", "\"\<F\>\"", ",", 
     "\"\<G\>\"", ",", "\"\<A\>\"", ",", "\"\<B\>\""}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CMelodicMinorDown", " ", "=", " ", "CNaturalMinor"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CChromaticSharps", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
    "\"\<C\>\"", ",", "\"\<C#\>\"", ",", "\"\<D\>\"", ",", "\"\<D#\>\"", ",", 
     "\"\<E\>\"", ",", "\"\<F\>\"", ",", "\"\<F#\>\"", ",", "\"\<G\>\"", ",", 
     "\"\<G#\>\"", ",", "\"\<A\>\"", ",", "\"\<A#\>\"", ",", "\"\<B\>\""}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CChromaticFlats", " ", "=", " ", 
    RowBox[{"{", 
     RowBox[{
     "\"\<C\>\"", ",", "\"\<Db\>\"", ",", "\"\<D\>\"", ",", "\"\<Eb\>\"", 
      ",", "\"\<E\>\"", ",", "\"\<F\>\"", ",", "\"\<Gb\>\"", ",", "\"\<G\>\"",
       ",", "\"\<Ab\>\"", ",", "\"\<A\>\"", ",", "\"\<Bb\>\"", ",", 
      "\"\<B\>\""}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PCR", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7",
      ",", "8", ",", "9", ",", "10", ",", "11"}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.8168480801813793`*^9, 3.81684813886124*^9}, {
   3.816848205060749*^9, 3.816848232244417*^9}, {3.816848318381489*^9, 
   3.8168483580051117`*^9}, {3.8168483987568827`*^9, 3.816848402725306*^9}, {
   3.8168484511339073`*^9, 3.816848487085754*^9}, {3.81684857323063*^9, 
   3.81684862643823*^9}, {3.816848658663518*^9, 3.816848709312335*^9}, {
   3.8170281508585043`*^9, 3.8170281830802937`*^9}, {3.8184039911934967`*^9, 
   3.818404003711362*^9}, 
   3.818404086360012*^9},ExpressionUUID->"91f6da45-8c2c-4d5f-a716-\
1a2fec30daee"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Utility functions", "Section",
 CellChangeTimes->{{3.81702819371235*^9, 
  3.817028199839848*^9}},ExpressionUUID->"fa860b7d-a912-454a-b9ad-\
71dce55d01bf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"z12", "[", "i_Integer", "]"}], " ", ":=", " ", 
  RowBox[{"Mod", "[", 
   RowBox[{"i", ",", "12"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8168480801813793`*^9, 3.81684813886124*^9}, {
   3.816848205060749*^9, 3.816848232244417*^9}, {3.816848318381489*^9, 
   3.8168483580051117`*^9}, {3.8168483987568827`*^9, 3.816848402725306*^9}, {
   3.8168484511339073`*^9, 3.816848487085754*^9}, {3.81684857323063*^9, 
   3.81684862643823*^9}, {3.816848658663518*^9, 3.816848724601514*^9}, 
   3.81702817416679*^9},
 CellLabel->"In[10]:=",ExpressionUUID->"25f79bc3-fef8-4070-ab07-800db8d75a2b"],

Cell[CellGroupData[{

Cell["Pitch classes", "Subsection",
 CellChangeTimes->{{3.8170282373442087`*^9, 
  3.817028239503735*^9}},ExpressionUUID->"80fe7a99-0793-41f6-aeae-\
a49a3755a7f0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"toPc", "[", 
    RowBox[{"pcr_Integer", ",", " ", 
     RowBox[{"sharps_", ":", "True"}]}], "]"}], " ", ":=", " ", 
   RowBox[{"If", "[", 
    RowBox[{"sharps", ",", "\[IndentingNewLine]", 
     RowBox[{"CChromaticSharps", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"z12", "[", "pcr", "]"}], " ", "+", " ", "1"}], "]"}], "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"CChromaticFlats", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"z12", "[", "pcr", "]"}], " ", "+", " ", "1"}], "]"}], 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"parsePc", "[", "pc_", "]"}], " ", ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"l", ",", "a"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"l", " ", "=", 
      RowBox[{"StringCases", "[", " ", 
       RowBox[{"pc", ",", 
        RowBox[{"RegularExpression", "[", "\"\<[A-G]\>\"", "]"}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"a", " ", "=", " ", 
      RowBox[{"StringCases", "[", 
       RowBox[{"pc", ",", 
        RowBox[{"RegularExpression", "[", "\"\<(bb|#|x|b|n)\>\"", "]"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"l", ",", "a"}], "}"}], "/.", 
       RowBox[{
        RowBox[{"{", "}"}], "\[Rule]", "\"\<\>\""}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"parsePc", ",", " ", "Listable"}], "]"}]}], "Input",
 CellChangeTimes->{{3.8168480801813793`*^9, 3.81684813886124*^9}, {
  3.816848205060749*^9, 3.816848232244417*^9}, {3.816848318381489*^9, 
  3.8168483580051117`*^9}, {3.8168483987568827`*^9, 3.816848402725306*^9}, {
  3.8168484511339073`*^9, 3.816848487085754*^9}, {3.81684857323063*^9, 
  3.81684862643823*^9}, {3.816848658663518*^9, 3.816848734255369*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"4cda0951-50ca-4fb0-8a19-e8ec6dca1948"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pitch class representatives", "Subsection",
 CellChangeTimes->{{3.817028264728153*^9, 3.817028268751709*^9}, 
   3.81840410200861*^9},ExpressionUUID->"41ba3d98-c2f6-4b91-840c-\
44b801fe611f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"toPcr", "[", "pc_", "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"letters", " ", "=", " ", 
       RowBox[{"<|", 
        RowBox[{
         RowBox[{"\"\<C\>\"", "\[Rule]", "0"}], ",", " ", 
         RowBox[{"\"\<D\>\"", "\[Rule]", "2"}], ",", " ", 
         RowBox[{"\"\<E\>\"", "\[Rule]", "4"}], ",", " ", 
         RowBox[{"\"\<F\>\"", "\[Rule]", "5"}], ",", " ", 
         RowBox[{"\"\<G\>\"", "\[Rule]", "7"}], ",", " ", 
         RowBox[{"\"\<A\>\"", "\[Rule]", "9"}], ",", " ", 
         RowBox[{"\"\<B\>\"", "\[Rule]", "11"}]}], "|>"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"accidentals", " ", "=", "  ", 
       RowBox[{"<|", " ", 
        RowBox[{
         RowBox[{"\"\<b\>\"", "\[Rule]", 
          RowBox[{"-", "1"}]}], ",", " ", 
         RowBox[{"\"\<bb\>\"", "\[Rule]", 
          RowBox[{"-", "2"}]}], ",", " ", 
         RowBox[{"\"\<n\>\"", "\[Rule]", "0"}], ",", " ", 
         RowBox[{"\"\<#\>\"", "\[Rule]", "1"}], ",", " ", 
         RowBox[{"\"\<x\>\"", "\[Rule]", "2"}], ",", " ", 
         RowBox[{"\"\<\>\"", "\[Rule]", "0"}]}], "|>"}]}], ",", 
      "\[IndentingNewLine]", "l", ",", " ", "a"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"l", ",", " ", "a"}], "}"}], " ", "=", " ", 
      RowBox[{"parsePc", "[", "pc", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"z12", "[", 
      RowBox[{
       RowBox[{"letters", "[", "l", "]"}], " ", "+", " ", 
       RowBox[{"accidentals", "[", "a", "]"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.8168480801813793`*^9, 3.81684813886124*^9}, {
   3.816848205060749*^9, 3.816848232244417*^9}, {3.816848318381489*^9, 
   3.8168483580051117`*^9}, {3.8168483987568827`*^9, 3.816848402725306*^9}, {
   3.8168484511339073`*^9, 3.816848487085754*^9}, {3.81684857323063*^9, 
   3.81684862643823*^9}, {3.816848658663518*^9, 3.8168487647969913`*^9}, {
   3.8168488006633177`*^9, 3.8168488085947933`*^9}, 3.817028272033022*^9},
 CellLabel->"In[14]:=",ExpressionUUID->"6802b626-e00b-4529-9230-5b83da9cbfd7"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Use", " ", "the", " ", "same", " ", "function", " ", "to", " ", "convert",
     " ", "Integers", " ", "to", " ", "pcrs"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"toPcr", "[", "num_Integer", "]"}], " ", ":=", " ", 
    RowBox[{"z12", "[", "num", "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"SetAttributes", "[", 
    RowBox[{"toPcr", ",", " ", "Listable"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.8168480801813793`*^9, 3.81684813886124*^9}, {
  3.816848205060749*^9, 3.816848232244417*^9}, {3.816848318381489*^9, 
  3.8168483580051117`*^9}, {3.8168483987568827`*^9, 3.816848402725306*^9}, {
  3.8168484511339073`*^9, 3.816848487085754*^9}, {3.81684857323063*^9, 
  3.81684862643823*^9}, {3.816848658663518*^9, 3.8168487647969913`*^9}, {
  3.8168488006633177`*^9, 3.8168488085947933`*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"9a6d4e29-8fa4-43fd-a606-992cfbdc33fe"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Scientific Pitch Notation and MIDI", "Section",
 CellChangeTimes->{{3.817028287448024*^9, 
  3.81702830648771*^9}},ExpressionUUID->"4fa865f2-8f81-4e6c-8ef2-\
92406202d020"],

Cell["\<\
Convert between Scientific Pitch Notation (e.g. C4) and MIDI (e.g. 60).\
\>", "Text",
 CellChangeTimes->{{3.818404127335957*^9, 
  3.81840414621564*^9}},ExpressionUUID->"3bb5ba84-ee50-40dd-aa8c-\
d392d17f178c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"parseSpn", "[", "spn_", "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"pc", ",", "o"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"pc", " ", "=", 
       RowBox[{"StringCases", "[", " ", 
        RowBox[{"spn", ",", 
         RowBox[{
         "RegularExpression", "[", "\"\<[A-G](bb|#|x|b|n)?\>\"", "]"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"o", " ", "=", 
       RowBox[{"ToExpression", "[", 
        RowBox[{"StringCases", "[", " ", 
         RowBox[{"spn", ",", 
          RowBox[{"RegularExpression", "[", "\"\<(-?)(\\\\d+)\>\"", "]"}]}], 
         "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Flatten", "[", 
       RowBox[{"{", 
        RowBox[{"pc", ",", "o"}], "}"}], "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"spnToMIDI", "[", "spn_", "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"l", ",", "o"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"l", ",", "o"}], "}"}], " ", "=", " ", 
      RowBox[{"parseSpn", "[", "spn", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"toPcr", "[", "l", "]"}], " ", "+", " ", 
      RowBox[{"12", "*", 
       RowBox[{"(", 
        RowBox[{"o", "+", "1"}], ")"}]}]}]}]}], "\[IndentingNewLine]", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"spnToMIDI", ",", " ", "Listable"}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MIDIToSpn", "[", "mid_Integer", "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"pcr", ",", "o"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"o", ",", "pcr"}], "}"}], " ", "=", " ", 
      RowBox[{"QuotientRemainder", "[", 
       RowBox[{"mid", ",", " ", "12"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"toPc", "[", "pcr", "]"}], "<>", 
      RowBox[{"ToString", "[", 
       RowBox[{"o", "-", "1"}], "]"}]}]}]}], "\[IndentingNewLine]", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"MIDIToSpn", ",", " ", "Listable"}], "]"}]}], "Input",
 CellChangeTimes->{{3.8168480801813793`*^9, 3.81684813886124*^9}, {
  3.816848205060749*^9, 3.816848232244417*^9}, {3.816848318381489*^9, 
  3.8168483580051117`*^9}, {3.8168483987568827`*^9, 3.816848402725306*^9}, {
  3.8168484511339073`*^9, 3.816848487085754*^9}, {3.81684857323063*^9, 
  3.81684862643823*^9}, {3.816848658663518*^9, 3.8168487579245033`*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"24d334d7-8b22-4b9a-a06a-c8f5782039f3"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tunings", "Section",
 CellChangeTimes->{{3.81702832353589*^9, 3.817028324551744*^9}, {
  3.8174531989942017`*^9, 
  3.817453199889565*^9}},ExpressionUUID->"a23b5cbd-cba5-4813-8cc5-\
56e3cd801c04"],

Cell["\<\
Scales as a pattern of intervals where 1 = semitone, 2 = tone, 3 = 3 \
semitones etc.\
\>", "Text",
 CellChangeTimes->{{3.818404158815708*^9, 
  3.818404186967564*^9}},ExpressionUUID->"00d4a45b-12a7-4d98-a42e-\
c894aaecdf5d"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ionianPattern", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "1", ",", "2", ",", "2", ",", "2", ",", "1"}],
     "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"aeolianPattern", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "2", ",", "2", ",", "1", ",", "2", ",", "2"}],
     "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mixolydianPattern", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "1", ",", "2", ",", "2", ",", "1", ",", "2"}],
     "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"chromaticPattern", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1",
      ",", "1", ",", "1", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"majorPentatonicPattern", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "3", ",", "2", ",", "3"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"minorPentatonicPattern", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2", ",", "2", ",", "3", ",", "2"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"bluesPattern", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2", ",", "1", ",", "1", ",", "3", ",", "2"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"spanishPhrygianPattern", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "1", ",", "2", ",", "1", ",", "2", ",", "2"}],
     "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"flamencoPattern", " ", "=", " ", 
    RowBox[{"{", 
     RowBox[{
     "2", ",", "1", ",", "3", ",", "1", ",", "1", ",", "3", ",", "1"}], 
     "}"}]}], ";", " ", 
   RowBox[{"(*", " ", 
    RowBox[{"Gypsy", " ", "minor"}], " ", "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"scaleFromPattern", "[", 
     RowBox[{"patt_", ",", " ", 
      RowBox[{"numNotes_", ":", "12"}]}], "]"}], " ", ":=", " ", 
    RowBox[{"Take", "[", 
     RowBox[{
      RowBox[{"Accumulate", "[", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", "0", "}"}], ",", "patt", ",", "patt", ",", " ", "patt", 
         ",", " ", "patt"}], "]"}], "]"}], ",", "12"}], "]"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"tmp", " ", "=", " ", 
  RowBox[{"Grid", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<Ionian\>\"", ",", " ", "SpanFromLeft"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"ionianPattern", ",", "SpanFromLeft"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"scaleFromPattern", "[", "ionianPattern", "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"toPc", "/@", 
       RowBox[{"scaleFromPattern", "[", "ionianPattern", "]"}]}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"\"\<Aeolian\>\"", ",", " ", "SpanFromLeft"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"aeolianPattern", ",", "SpanFromLeft"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"scaleFromPattern", "[", "aeolianPattern", "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"toPc", "/@", 
       RowBox[{"scaleFromPattern", "[", "aeolianPattern", "]"}]}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"\"\<Mixolydian\>\"", ",", " ", "SpanFromLeft"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"mixolydianPattern", ",", " ", "SpanFromLeft"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"scaleFromPattern", "[", "mixolydianPattern", "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"toPc", "/@", 
       RowBox[{"scaleFromPattern", "[", "mixolydianPattern", "]"}]}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"\"\<Chromatic\>\"", ",", " ", "SpanFromLeft"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"chromaticPattern", ",", " ", "SpanFromLeft"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"scaleFromPattern", "[", "chromaticPattern", "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"toPc", "/@", 
       RowBox[{"scaleFromPattern", "[", "chromaticPattern", "]"}]}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"\"\<Major pentatonic\>\"", ",", " ", "SpanFromLeft"}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"majorPentatonicPattern", ",", " ", "SpanFromLeft"}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"scaleFromPattern", "[", "majorPentatonicPattern", "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"toPc", "/@", 
       RowBox[{"scaleFromPattern", "[", "majorPentatonicPattern", "]"}]}], 
      ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"\"\<Minor pentatonic\>\"", ",", " ", "SpanFromLeft"}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"minorPentatonicPattern", ",", " ", "SpanFromLeft"}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"scaleFromPattern", "[", "minorPentatonicPattern", "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"toPc", "/@", 
       RowBox[{"scaleFromPattern", "[", "minorPentatonicPattern", "]"}]}], 
      ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"\"\<Blues\>\"", ",", " ", "SpanFromLeft"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"bluesPattern", ",", " ", "SpanFromLeft"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"scaleFromPattern", "[", "bluesPattern", "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"toPc", "/@", 
       RowBox[{"scaleFromPattern", "[", "bluesPattern", "]"}]}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"\"\<Spanish phrygian\>\"", ",", " ", "SpanFromLeft"}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"spanishPhrygianPattern", ",", " ", "SpanFromLeft"}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"scaleFromPattern", "[", "spanishPhrygianPattern", "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"toPc", "/@", 
       RowBox[{"scaleFromPattern", "[", "spanishPhrygianPattern", "]"}]}], 
      ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"\"\<Flamenco\>\"", ",", " ", "SpanFromLeft"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"flamencoPattern", ",", " ", "SpanFromLeft"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"scaleFromPattern", "[", "flamencoPattern", "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"toPc", "/@", 
       RowBox[{"scaleFromPattern", "[", "flamencoPattern", "]"}]}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", " ", 
    RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}]}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQB2IQvUNbPTa94I1jjPfaNBB96v7RbBBd9fFEKYhmKl1Z
CaIrbd1bQTTXfLfJIPrcdYEpILq8yWwuiFZJ9twCorNYDu8A0SfYrM+DaCcT
3xcgeoad3hsQncvo+h1Ebz/a8g9EL5vmwZYBpOefbhMC0ay5OVogetlPVlMQ
3Xdmki2IfjzjtR2Irnh3MwxEG/VkxIPoSS33WkD0gRvbO0D0LnHdnkwgvcFl
PpiWkohuyALSnzY6toPo5UJOXfeA9HPzm4tAdOfSp5tAtKz8hG0g+odH/G4Q
XcOwdj+I/rZ41vZHQPraO5M9IFp0p9IxED3x8d7TILqpUHvKByA94cWCBSDa
ZVHSURAdlL4TTCvqCZ4D0bsmmYNpANs5xEE=
  "],
 CellLabel->
  "In[224]:=",ExpressionUUID->"58bfbb3e-8a4f-4994-9ee0-5d22d284ff12"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"Ionian\"\>", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {
     RowBox[{"{", 
      RowBox[{
      "2", ",", "2", ",", "1", ",", "2", ",", "2", ",", "2", ",", "1"}], 
      "}"}], "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {"0", "2", "4", "5", "7", "9", "11", "12", "14", "16", "17", "19"},
    {"\<\"C\"\>", "\<\"D\"\>", "\<\"E\"\>", "\<\"F\"\>", "\<\"G\"\>", \
"\<\"A\"\>", "\<\"B\"\>", "\<\"C\"\>", "\<\"D\"\>", "\<\"E\"\>", "\<\"F\"\>", \
"\<\"G\"\>"},
    {"\<\"Aeolian\"\>", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {
     RowBox[{"{", 
      RowBox[{
      "2", ",", "1", ",", "2", ",", "2", ",", "1", ",", "2", ",", "2"}], 
      "}"}], "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {"0", "2", "3", "5", "7", "8", "10", "12", "14", "15", "17", "19"},
    {"\<\"C\"\>", "\<\"D\"\>", "\<\"D#\"\>", "\<\"F\"\>", "\<\"G\"\>", \
"\<\"G#\"\>", "\<\"A#\"\>", "\<\"C\"\>", "\<\"D\"\>", "\<\"D#\"\>", \
"\<\"F\"\>", "\<\"G\"\>"},
    {"\<\"Mixolydian\"\>", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {
     RowBox[{"{", 
      RowBox[{
      "2", ",", "2", ",", "1", ",", "2", ",", "2", ",", "1", ",", "2"}], 
      "}"}], "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {"0", "2", "4", "5", "7", "9", "10", "12", "14", "16", "17", "19"},
    {"\<\"C\"\>", "\<\"D\"\>", "\<\"E\"\>", "\<\"F\"\>", "\<\"G\"\>", \
"\<\"A\"\>", "\<\"A#\"\>", "\<\"C\"\>", "\<\"D\"\>", "\<\"E\"\>", \
"\<\"F\"\>", "\<\"G\"\>"},
    {"\<\"Chromatic\"\>", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
       "1", ",", "1", ",", "1", ",", "1"}], "}"}], "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]"},
    {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11"},
    {"\<\"C\"\>", "\<\"C#\"\>", "\<\"D\"\>", "\<\"D#\"\>", "\<\"E\"\>", \
"\<\"F\"\>", "\<\"F#\"\>", "\<\"G\"\>", "\<\"G#\"\>", "\<\"A\"\>", \
"\<\"A#\"\>", "\<\"B\"\>"},
    {"\<\"Major pentatonic\"\>", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "3", ",", "2", ",", "3"}], "}"}], 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {"0", "2", "4", "7", "9", "12", "14", "16", "19", "21", "24", "26"},
    {"\<\"C\"\>", "\<\"D\"\>", "\<\"E\"\>", "\<\"G\"\>", "\<\"A\"\>", \
"\<\"C\"\>", "\<\"D\"\>", "\<\"E\"\>", "\<\"G\"\>", "\<\"A\"\>", "\<\"C\"\>", \
"\<\"D\"\>"},
    {"\<\"Minor pentatonic\"\>", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {
     RowBox[{"{", 
      RowBox[{"3", ",", "2", ",", "2", ",", "3", ",", "2"}], "}"}], 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {"0", "3", "5", "7", "10", "12", "15", "17", "19", "22", "24", "27"},
    {"\<\"C\"\>", "\<\"D#\"\>", "\<\"F\"\>", "\<\"G\"\>", "\<\"A#\"\>", \
"\<\"C\"\>", "\<\"D#\"\>", "\<\"F\"\>", "\<\"G\"\>", "\<\"A#\"\>", \
"\<\"C\"\>", "\<\"D#\"\>"},
    {"\<\"Blues\"\>", "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]",
      "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {
     RowBox[{"{", 
      RowBox[{"3", ",", "2", ",", "1", ",", "1", ",", "3", ",", "2"}], "}"}], 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {"0", "3", "5", "6", "7", "10", "12", "15", "17", "18", "19", "22"},
    {"\<\"C\"\>", "\<\"D#\"\>", "\<\"F\"\>", "\<\"F#\"\>", "\<\"G\"\>", \
"\<\"A#\"\>", "\<\"C\"\>", "\<\"D#\"\>", "\<\"F\"\>", "\<\"F#\"\>", \
"\<\"G\"\>", "\<\"A#\"\>"},
    {"\<\"Spanish phrygian\"\>", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {
     RowBox[{"{", 
      RowBox[{
      "1", ",", "3", ",", "1", ",", "2", ",", "1", ",", "2", ",", "2"}], 
      "}"}], "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {"0", "1", "4", "5", "7", "8", "10", "12", "13", "16", "17", "19"},
    {"\<\"C\"\>", "\<\"C#\"\>", "\<\"E\"\>", "\<\"F\"\>", "\<\"G\"\>", \
"\<\"G#\"\>", "\<\"A#\"\>", "\<\"C\"\>", "\<\"C#\"\>", "\<\"E\"\>", \
"\<\"F\"\>", "\<\"G\"\>"},
    {"\<\"Flamenco\"\>", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {
     RowBox[{"{", 
      RowBox[{
      "2", ",", "1", ",", "3", ",", "1", ",", "1", ",", "3", ",", "1"}], 
      "}"}], "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
     "\[SpanFromLeft]", "\[SpanFromLeft]"},
    {"0", "2", "3", "6", "7", "8", "11", "12", "14", "15", "18", "19"},
    {"\<\"C\"\>", "\<\"D\"\>", "\<\"D#\"\>", "\<\"F#\"\>", "\<\"G\"\>", \
"\<\"G#\"\>", "\<\"B\"\>", "\<\"C\"\>", "\<\"D\"\>", "\<\"D#\"\>", \
"\<\"F#\"\>", "\<\"G\"\>"}
   },
   AutoDelete->False,
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{{3.8173094313969803`*^9, 3.817309445969997*^9}, {
   3.817309729281103*^9, 3.8173097424654016`*^9}, 3.817309812647579*^9},
 CellLabel->
  "Out[233]=",ExpressionUUID->"5c16fb40-1463-4a2a-97b5-37d08e7a33c5"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<scaleTable.csv\>\""}],
    ",", " ", "tmp", ",", " ", "\"\<CSV\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.817309815946364*^9, 3.8173098851990223`*^9}, {
  3.81730991625564*^9, 3.817309924311428*^9}},
 CellLabel->
  "In[235]:=",ExpressionUUID->"b23b565a-df5c-4c1d-aea7-13e1b6e3c1b0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Convert to C code", "Section",
 CellChangeTimes->{{3.817030958519384*^9, 
  3.817030961983053*^9}},ExpressionUUID->"855d44c0-b9cd-44c3-891b-\
d48523c698bd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hilightRules", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"0", "\[Rule]", "DARK_RED"}], ",", " ", "\[IndentingNewLine]", 
     RowBox[{"1", "\[Rule]", "0"}], ",", " ", 
     RowBox[{"2", "\[Rule]", "0"}], ",", " ", 
     RowBox[{"3", "\[Rule]", "0"}], ",", " ", "\[IndentingNewLine]", 
     RowBox[{"4", "\[Rule]", "DARK_YELLOW"}], ",", "\[IndentingNewLine]", 
     RowBox[{"5", "\[Rule]", "0"}], ",", " ", 
     RowBox[{"6", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"7", "\[Rule]", "DARK_GREEN"}], ",", "\[IndentingNewLine]", 
     RowBox[{"8", "\[Rule]", "0"}], ",", " ", 
     RowBox[{"9", "\[Rule]", "0"}], ",", 
     RowBox[{"10", "\[Rule]", "0"}], ",", " ", 
     RowBox[{"11", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"12", "\[Rule]", "DARK_RED"}], ",", "\[IndentingNewLine]", 
     RowBox[{"13", "\[Rule]", "0"}], ",", 
     RowBox[{"14", "\[Rule]", "0"}], ",", 
     RowBox[{"15", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"16", "\[Rule]", "DARK_YELLOW"}], ",", "\[IndentingNewLine]", 
     RowBox[{"17", "\[Rule]", "0"}], ",", " ", 
     RowBox[{"18", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"19", "\[Rule]", "DARK_GREEN"}], ",", "\[IndentingNewLine]", 
     RowBox[{"20", "\[Rule]", "0"}], ",", " ", 
     RowBox[{"21", "\[Rule]", "0"}], ",", " ", 
     RowBox[{"22", "\[Rule]", "0"}], ",", " ", 
     RowBox[{"23", "\[Rule]", "0"}], ",", " ", "\[IndentingNewLine]", 
     RowBox[{"24", "\[Rule]", "DARK_RED"}], ",", "\[IndentingNewLine]", 
     RowBox[{"25", "\[Rule]", "0"}], ",", 
     RowBox[{"26", "\[Rule]", "0"}], ",", 
     RowBox[{"27", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"X", "\[Rule]", "0"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.817031311718232*^9, 3.81703141558983*^9}, {
   3.8170314591017313`*^9, 3.817031589901463*^9}, {3.817031623286331*^9, 
   3.8170316261491213`*^9}, {3.817031700830145*^9, 3.81703172095673*^9}, {
   3.817031756326239*^9, 3.817031757604718*^9}, {3.817032874560828*^9, 
   3.817032894823851*^9}, {3.81703314543469*^9, 3.817033171297707*^9}, 
   3.817453671974444*^9},ExpressionUUID->"85a6df87-d037-44bf-8b33-\
dc5626b848c0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"toOffsetArray", "[", "scale_", "]"}], " ", ":=", " ", 
   RowBox[{"Riffle", "[", 
    RowBox[{"scale", ",", " ", 
     RowBox[{"Table", "[", 
      RowBox[{"X", ",", " ", 
       RowBox[{"{", 
        RowBox[{"i", ",", " ", "1", ",", "12"}], "}"}]}], "]"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"toHilightArray", "[", "scale_", "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"Riffle", "[", 
    RowBox[{"scale", ",", " ", 
     RowBox[{"Table", "[", 
      RowBox[{"X", ",", " ", 
       RowBox[{"{", 
        RowBox[{"i", ",", " ", "1", ",", "12"}], "}"}]}], "]"}]}], "]"}], "/.",
    "hilightRules"}]}]}], "Input",
 CellChangeTimes->{{3.817028711790824*^9, 3.8170287256226263`*^9}, {
   3.817029962536846*^9, 3.817029966628759*^9}, {3.817030319798869*^9, 
   3.817030323628125*^9}, {3.817030978624303*^9, 3.817031302918007*^9}, {
   3.8170315952692337`*^9, 3.8170315975571423`*^9}, {3.817031759917487*^9, 
   3.817031764364489*^9}, 3.817031811648944*^9, 3.817032191995288*^9},
 CellLabel->
  "In[241]:=",ExpressionUUID->"58298d8f-afd7-4d6e-b080-273ded9370fb"],

Cell[CellGroupData[{

Cell["Ionian", "Subsection",
 CellChangeTimes->{{3.817032211286097*^9, 3.817032212093605*^9}, {
  3.817032378573657*^9, 
  3.817032378773286*^9}},ExpressionUUID->"1e23093c-32d3-48e6-b74e-\
0de935bdb6b4"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"toOffsetArray", "[", 
  RowBox[{"scaleFromPattern", "[", "ionianPattern", "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"toHilightArray", "[", 
  RowBox[{"scaleFromPattern", "[", "ionianPattern", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.817028711790824*^9, 3.8170287256226263`*^9}, {
   3.817029962536846*^9, 3.817029966628759*^9}, {3.817030319798869*^9, 
   3.817030323628125*^9}, {3.817030978624303*^9, 3.817031302918007*^9}, {
   3.8170315952692337`*^9, 3.8170315975571423`*^9}, {3.817031759917487*^9, 
   3.817031764364489*^9}, 3.817031811648944*^9, 
   3.817032191995288*^9},ExpressionUUID->"8051f445-705c-4d86-a685-\
717f5668b38c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "X", ",", "2", ",", "X", ",", "4", ",", "X", ",", "5", ",", "X", 
   ",", "7", ",", "X", ",", "9", ",", "X", ",", "11", ",", "X", ",", "12", 
   ",", "X", ",", "14", ",", "X", ",", "16", ",", "X", ",", "17", ",", "X", 
   ",", "19", ",", "X"}], "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.8170320429540243`*^9},
 CellLabel->
  "Out[1078]=",ExpressionUUID->"dc9ae9ef-eb40-4839-8ea4-ec3686ade820"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "DARK_RED", ",", "0", ",", "0", ",", "0", ",", "DARK_YELLOW", ",", "0", ",",
    "0", ",", "0", ",", "DARK_GREEN", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "0", ",", "DARK_RED", ",", "0", ",", "0", ",", "0", ",", 
   "DARK_YELLOW", ",", "0", ",", "0", ",", "0", ",", "DARK_GREEN", ",", "0"}],
   "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.817032042955884*^9},
 CellLabel->
  "Out[1079]=",ExpressionUUID->"fade1e82-c86e-4ac5-8e7e-126ab26e6d4b"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Aeolian", "Subsection",
 CellChangeTimes->{{3.817032211286097*^9, 3.817032212093605*^9}, {
  3.817032378573657*^9, 3.817032378773286*^9}, {3.817453255594421*^9, 
  3.817453257217938*^9}},ExpressionUUID->"c9e115b3-8edb-4d15-b3f2-\
c32c1c5903f1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"toOffsetArray", "[", 
  RowBox[{"scaleFromPattern", "[", "aeolianPattern", "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"toHilightArray", "[", 
  RowBox[{"scaleFromPattern", "[", "aeolianPattern", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.817028711790824*^9, 3.8170287256226263`*^9}, {
   3.817029962536846*^9, 3.817029966628759*^9}, {3.817030319798869*^9, 
   3.817030323628125*^9}, {3.817030978624303*^9, 3.817031302918007*^9}, {
   3.8170315952692337`*^9, 3.8170315975571423`*^9}, {3.817031759917487*^9, 
   3.817031764364489*^9}, 3.817031811648944*^9, 3.817032191995288*^9, {
   3.817453263754784*^9, 3.81745327005163*^9}},
 CellLabel->
  "In[243]:=",ExpressionUUID->"1ef9c121-eeb3-48cb-92e2-a5c3ea11960e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "X", ",", "2", ",", "X", ",", "3", ",", "X", ",", "5", ",", "X", 
   ",", "7", ",", "X", ",", "8", ",", "X", ",", "10", ",", "X", ",", "12", 
   ",", "X", ",", "14", ",", "X", ",", "15", ",", "X", ",", "17", ",", "X", 
   ",", "19", ",", "X"}], "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.8170320429540243`*^9, 3.8174532731088142`*^9},
 CellLabel->
  "Out[243]=",ExpressionUUID->"a18ea909-fb87-490e-a5c4-365f73e356ec"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "DARK_RED", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",",
    "0", ",", "DARK_GREEN", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "DARK_RED", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
   "0", ",", "0", ",", "DARK_GREEN", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.8170320429540243`*^9, 3.8174532731098213`*^9},
 CellLabel->
  "Out[244]=",ExpressionUUID->"f09fc328-b84d-4820-a8d7-010c9e479324"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Mixolydian", "Subsection",
 CellChangeTimes->{{3.817032211286097*^9, 3.817032212093605*^9}, {
  3.817032378573657*^9, 3.817032378773286*^9}, {3.817033295538746*^9, 
  3.8170332973215227`*^9}},ExpressionUUID->"142d9c07-6ae9-4219-99ed-\
f7e41c8eb704"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"toOffsetArray", "[", 
  RowBox[{"scaleFromPattern", "[", "mixolydianPattern", "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"toHilightArray", "[", 
  RowBox[{"scaleFromPattern", "[", "mixolydianPattern", "]"}], "]"}]}], \
"Input",
 CellChangeTimes->{{3.817028711790824*^9, 3.8170287256226263`*^9}, {
   3.817029962536846*^9, 3.817029966628759*^9}, {3.817030319798869*^9, 
   3.817030323628125*^9}, {3.817030978624303*^9, 3.817031302918007*^9}, {
   3.8170315952692337`*^9, 3.8170315975571423`*^9}, {3.817031759917487*^9, 
   3.817031764364489*^9}, 3.817031811648944*^9, 3.817032191995288*^9, {
   3.817033308635401*^9, 3.8170333099315367`*^9}},
 CellLabel->
  "In[1102]:=",ExpressionUUID->"e4277149-6e57-43d2-b973-9875252c9deb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "X", ",", "2", ",", "X", ",", "4", ",", "X", ",", "5", ",", "X", 
   ",", "7", ",", "X", ",", "9", ",", "X", ",", "10", ",", "X", ",", "12", 
   ",", "X", ",", "14", ",", "X", ",", "16", ",", "X", ",", "17", ",", "X", 
   ",", "19", ",", "X"}], "}"}]], "Output",
 CellChangeTimes->{3.8170333248945847`*^9},
 CellLabel->
  "Out[1102]=",ExpressionUUID->"ea839d41-067b-4b56-bae8-12db8e6b05bb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "DARK_RED", ",", "0", ",", "0", ",", "0", ",", "DARK_YELLOW", ",", "0", ",",
    "0", ",", "0", ",", "DARK_GREEN", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "0", ",", "DARK_RED", ",", "0", ",", "0", ",", "0", ",", 
   "DARK_YELLOW", ",", "0", ",", "0", ",", "0", ",", "DARK_GREEN", ",", "0"}],
   "}"}]], "Output",
 CellChangeTimes->{3.817033324896887*^9},
 CellLabel->
  "Out[1103]=",ExpressionUUID->"5c90a20d-c325-4624-8fd3-1a7e4850f909"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "X", ",", "2", ",", "X", ",", "4", ",", "X", ",", "5", ",", "X", 
   ",", "7", ",", "X", ",", "9", ",", "X", ",", "11", ",", "X", ",", "12", 
   ",", "X", ",", "14", ",", "X", ",", "16", ",", "X", ",", "17", ",", "X", 
   ",", "19", ",", "X"}], "}"}]], "Input",
 CellChangeTimes->{3.81703331155519*^9},
 CellLabel->
  "In[1101]:=",ExpressionUUID->"3382b813-8cf3-492e-a1f7-f49687a9f574"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "X", ",", "2", ",", "X", ",", "4", ",", "X", ",", "5", ",", "X", 
   ",", "7", ",", "X", ",", "9", ",", "X", ",", "11", ",", "X", ",", "12", 
   ",", "X", ",", "14", ",", "X", ",", "16", ",", "X", ",", "17", ",", "X", 
   ",", "19", ",", "X"}], "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.817032042955884*^9, 3.817033311588584*^9},
 CellLabel->
  "Out[1101]=",ExpressionUUID->"7e18c076-65ab-4d2d-84f4-757e07bc422e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Chromatic", "Subsection",
 CellChangeTimes->{{3.817032211286097*^9, 3.817032212093605*^9}, {
  3.817032378573657*^9, 3.817032387621009*^9}, {3.8170327685188713`*^9, 
  3.8170327686463003`*^9}},ExpressionUUID->"376c6cab-4f73-4abb-b1c5-\
1113e505037f"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"toOffsetArray", "[", 
  RowBox[{"scaleFromPattern", "[", "chromaticPattern", "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"toHilightArray", "[", 
  RowBox[{"scaleFromPattern", "[", "chromaticPattern", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.817028711790824*^9, 3.8170287256226263`*^9}, {
   3.817029962536846*^9, 3.817029966628759*^9}, {3.817030319798869*^9, 
   3.817030323628125*^9}, {3.817030978624303*^9, 3.817031302918007*^9}, {
   3.8170315952692337`*^9, 3.8170315975571423`*^9}, {3.817031759917487*^9, 
   3.817031764364489*^9}, 3.817031811648944*^9, 3.817032191995288*^9, {
   3.8170323923495493`*^9, 3.817032398933139*^9}},
 CellLabel->
  "In[1080]:=",ExpressionUUID->"4a0ad33c-ee24-4eaa-bc3e-fef46e3dcec8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "X", ",", "1", ",", "X", ",", "2", ",", "X", ",", "3", ",", "X", 
   ",", "4", ",", "X", ",", "5", ",", "X", ",", "6", ",", "X", ",", "7", ",", 
   "X", ",", "8", ",", "X", ",", "9", ",", "X", ",", "10", ",", "X", ",", 
   "11", ",", "X"}], "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.8170320429540243`*^9, 3.81703240136798*^9},
 CellLabel->
  "Out[1080]=",ExpressionUUID->"db9c3d21-78ad-4db1-a910-5f7eec2e8196"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "DARK_RED", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",",
    "0", ",", "DARK_YELLOW", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
    ",", "DARK_GREEN", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
   "0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.8170320429540243`*^9, 3.81703240136998*^9},
 CellLabel->
  "Out[1081]=",ExpressionUUID->"0a59ec4f-ca93-486c-bf1c-c6c73ce9035e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Major pentatonic", "Subsection",
 CellChangeTimes->{{3.817032211286097*^9, 3.817032212093605*^9}, {
  3.817032378573657*^9, 3.817032387621009*^9}, {3.8170327685188713`*^9, 
  3.817032778054562*^9}},ExpressionUUID->"7787aaa7-2f21-4433-bfb2-\
5b92f5da3752"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"toOffsetArray", "[", 
  RowBox[{"scaleFromPattern", "[", "majorPentatonicPattern", "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"toHilightArray", "[", 
  RowBox[{"scaleFromPattern", "[", "majorPentatonicPattern", "]"}], "]"}]}], \
"Input",
 CellChangeTimes->{{3.817028711790824*^9, 3.8170287256226263`*^9}, {
   3.817029962536846*^9, 3.817029966628759*^9}, {3.817030319798869*^9, 
   3.817030323628125*^9}, {3.817030978624303*^9, 3.817031302918007*^9}, {
   3.8170315952692337`*^9, 3.8170315975571423`*^9}, {3.817031759917487*^9, 
   3.817031764364489*^9}, 3.817031811648944*^9, 3.817032191995288*^9, {
   3.8170323923495493`*^9, 3.817032398933139*^9}, {3.8170327829676943`*^9, 
   3.817032816120308*^9}},
 CellLabel->
  "In[1094]:=",ExpressionUUID->"592dff2d-fe4b-425b-8d45-334e3d3d8cf3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "X", ",", "2", ",", "X", ",", "4", ",", "X", ",", "7", ",", "X", 
   ",", "9", ",", "X", ",", "12", ",", "X", ",", "14", ",", "X", ",", "16", 
   ",", "X", ",", "19", ",", "X", ",", "21", ",", "X", ",", "24", ",", "X", 
   ",", "26", ",", "X"}], "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.8170320429540243`*^9, 3.81703240136798*^9, 3.8170328186337233`*^9, 
   3.817032901845224*^9},
 CellLabel->
  "Out[1094]=",ExpressionUUID->"2dcfc781-7611-46d9-b277-36f970275fbd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "DARK_RED", ",", "0", ",", "0", ",", "0", ",", "DARK_YELLOW", ",", "0", ",",
    "DARK_GREEN", ",", "0", ",", "0", ",", "0", ",", "DARK_RED", ",", "0", 
   ",", "0", ",", "0", ",", "DARK_YELLOW", ",", "0", ",", "DARK_GREEN", ",", 
   "0", ",", "0", ",", "0", ",", "DARK_RED", ",", "0", ",", "0", ",", "0"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.8170320429540243`*^9, 3.81703240136798*^9, 3.8170328186337233`*^9, 
   3.817032901847251*^9},
 CellLabel->
  "Out[1095]=",ExpressionUUID->"83c77a5d-ab7e-4053-8ab9-76cdce60a6d8"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Minor pentatonic", "Subsection",
 CellChangeTimes->{{3.817032211286097*^9, 3.817032212093605*^9}, {
  3.817032378573657*^9, 3.817032387621009*^9}, {3.8170327685188713`*^9, 
  3.817032778054562*^9}, {3.817033040616753*^9, 
  3.817033041216345*^9}},ExpressionUUID->"f10cbda5-a9ba-48cd-8988-\
84b9207dc79c"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"toOffsetArray", "[", 
  RowBox[{"scaleFromPattern", "[", "minorPentatonicPattern", "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"toHilightArray", "[", 
  RowBox[{"scaleFromPattern", "[", "minorPentatonicPattern", "]"}], "]"}]}], \
"Input",
 CellChangeTimes->{{3.817028711790824*^9, 3.8170287256226263`*^9}, {
   3.817029962536846*^9, 3.817029966628759*^9}, {3.817030319798869*^9, 
   3.817030323628125*^9}, {3.817030978624303*^9, 3.817031302918007*^9}, {
   3.8170315952692337`*^9, 3.8170315975571423`*^9}, {3.817031759917487*^9, 
   3.817031764364489*^9}, 3.817031811648944*^9, 3.817032191995288*^9, {
   3.8170323923495493`*^9, 3.817032398933139*^9}, {3.8170327829676943`*^9, 
   3.817032816120308*^9}, {3.817033044689179*^9, 3.817033050344488*^9}},
 CellLabel->
  "In[1099]:=",ExpressionUUID->"ecedf9ad-f4ec-4898-863f-5e1ba891c4b4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "X", ",", "3", ",", "X", ",", "5", ",", "X", ",", "7", ",", "X", 
   ",", "10", ",", "X", ",", "12", ",", "X", ",", "15", ",", "X", ",", "17", 
   ",", "X", ",", "19", ",", "X", ",", "22", ",", "X", ",", "24", ",", "X", 
   ",", "27", ",", "X"}], "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.8170320429540243`*^9, 3.81703240136798*^9, 3.8170328186337233`*^9, 
   3.817032901845224*^9, 3.8170330524292583`*^9, 3.817033175765851*^9},
 CellLabel->
  "Out[1099]=",ExpressionUUID->"d9d0eabf-9a49-410f-b12f-e021ea0081c3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "DARK_RED", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
   "DARK_GREEN", ",", "0", ",", "0", ",", "0", ",", "DARK_RED", ",", "0", ",",
    "0", ",", "0", ",", "0", ",", "0", ",", "DARK_GREEN", ",", "0", ",", "0", 
   ",", "0", ",", "DARK_RED", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",\

 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.8170320429540243`*^9, 3.81703240136798*^9, 3.8170328186337233`*^9, 
   3.817032901845224*^9, 3.8170330524292583`*^9, 3.81703317576786*^9},
 CellLabel->
  "Out[1100]=",ExpressionUUID->"481257ec-a883-4c38-a981-2c3a73ddad36"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Blues", "Subsection",
 CellChangeTimes->{{3.817032211286097*^9, 3.817032212093605*^9}, {
  3.817032378573657*^9, 3.817032387621009*^9}, {3.8170327685188713`*^9, 
  3.817032778054562*^9}, {3.817033040616753*^9, 3.817033041216345*^9}, {
  3.817033353994588*^9, 
  3.817033354810561*^9}},ExpressionUUID->"8f176a2a-927b-4240-b864-\
21d33a9aceb7"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"toOffsetArray", "[", 
  RowBox[{"scaleFromPattern", "[", "bluesPattern", "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"toHilightArray", "[", 
  RowBox[{"scaleFromPattern", "[", "bluesPattern", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.817028711790824*^9, 3.8170287256226263`*^9}, {
   3.817029962536846*^9, 3.817029966628759*^9}, {3.817030319798869*^9, 
   3.817030323628125*^9}, {3.817030978624303*^9, 3.817031302918007*^9}, {
   3.8170315952692337`*^9, 3.8170315975571423`*^9}, {3.817031759917487*^9, 
   3.817031764364489*^9}, 3.817031811648944*^9, 3.817032191995288*^9, {
   3.8170323923495493`*^9, 3.817032398933139*^9}, {3.8170327829676943`*^9, 
   3.817032816120308*^9}, {3.817033044689179*^9, 3.817033050344488*^9}, {
   3.81703335984317*^9, 3.817033364291978*^9}},
 CellLabel->
  "In[1104]:=",ExpressionUUID->"22eb76a2-a5d6-438f-8800-5b7fa43a367c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "X", ",", "3", ",", "X", ",", "5", ",", "X", ",", "6", ",", "X", 
   ",", "7", ",", "X", ",", "10", ",", "X", ",", "12", ",", "X", ",", "15", 
   ",", "X", ",", "17", ",", "X", ",", "18", ",", "X", ",", "19", ",", "X", 
   ",", "22", ",", "X"}], "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.8170320429540243`*^9, 3.81703240136798*^9, 3.8170328186337233`*^9, 
   3.817032901845224*^9, 3.8170330524292583`*^9, 3.817033175765851*^9, 
   3.817033366872793*^9},
 CellLabel->
  "Out[1104]=",ExpressionUUID->"14ef08a7-a8be-4213-be9b-776aded97d67"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "DARK_RED", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",",
    "0", ",", "DARK_GREEN", ",", "0", ",", "0", ",", "0", ",", "DARK_RED", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
   "DARK_GREEN", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.8170320429540243`*^9, 3.81703240136798*^9, 3.8170328186337233`*^9, 
   3.817032901845224*^9, 3.8170330524292583`*^9, 3.817033175765851*^9, 
   3.817033366874857*^9},
 CellLabel->
  "Out[1105]=",ExpressionUUID->"2eadc398-5dcc-40f9-a7ca-660eaab42f0a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Spanish phrygian", "Subsection",
 CellChangeTimes->{{3.817032211286097*^9, 3.817032212093605*^9}, {
  3.817032378573657*^9, 3.817032387621009*^9}, {3.8170327685188713`*^9, 
  3.817032778054562*^9}, {3.817033040616753*^9, 3.817033041216345*^9}, {
  3.817033353994588*^9, 3.817033354810561*^9}, {3.817033859705962*^9, 
  3.817033863353582*^9}},ExpressionUUID->"02bf9110-4055-41ab-9892-\
c1ee4ba0e965"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"toOffsetArray", "[", 
  RowBox[{"scaleFromPattern", "[", "spanishPhrygianPattern", "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"toHilightArray", "[", 
  RowBox[{"scaleFromPattern", "[", "spanishPhrygianPattern", "]"}], "]"}]}], \
"Input",
 CellChangeTimes->{{3.817028711790824*^9, 3.8170287256226263`*^9}, {
   3.817029962536846*^9, 3.817029966628759*^9}, {3.817030319798869*^9, 
   3.817030323628125*^9}, {3.817030978624303*^9, 3.817031302918007*^9}, {
   3.8170315952692337`*^9, 3.8170315975571423`*^9}, {3.817031759917487*^9, 
   3.817031764364489*^9}, 3.817031811648944*^9, 3.817032191995288*^9, {
   3.8170323923495493`*^9, 3.817032398933139*^9}, {3.8170327829676943`*^9, 
   3.817032816120308*^9}, {3.817033044689179*^9, 3.817033050344488*^9}, {
   3.81703335984317*^9, 3.817033364291978*^9}, {3.817033882876059*^9, 
   3.817033884195074*^9}},
 CellLabel->
  "In[1108]:=",ExpressionUUID->"11fc8d92-c878-4ec1-b99c-cc86fcfe513d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "X", ",", "1", ",", "X", ",", "4", ",", "X", ",", "5", ",", "X", 
   ",", "7", ",", "X", ",", "8", ",", "X", ",", "10", ",", "X", ",", "12", 
   ",", "X", ",", "13", ",", "X", ",", "16", ",", "X", ",", "17", ",", "X", 
   ",", "19", ",", "X"}], "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.8170320429540243`*^9, 3.81703240136798*^9, 3.8170328186337233`*^9, 
   3.817032901845224*^9, 3.8170330524292583`*^9, 3.817033175765851*^9, 
   3.817033366872793*^9, 3.8170338871655188`*^9, 3.8170339532517843`*^9},
 CellLabel->
  "Out[1108]=",ExpressionUUID->"9c93a520-3d5d-4d14-b1b0-c7b347d1e19c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "DARK_RED", ",", "0", ",", "0", ",", "0", ",", "DARK_YELLOW", ",", "0", ",",
    "0", ",", "0", ",", "DARK_GREEN", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "0", ",", "DARK_RED", ",", "0", ",", "0", ",", "0", ",", 
   "DARK_YELLOW", ",", "0", ",", "0", ",", "0", ",", "DARK_GREEN", ",", "0"}],
   "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.8170320429540243`*^9, 3.81703240136798*^9, 3.8170328186337233`*^9, 
   3.817032901845224*^9, 3.8170330524292583`*^9, 3.817033175765851*^9, 
   3.817033366872793*^9, 3.8170338871655188`*^9, 3.8170339532541513`*^9},
 CellLabel->
  "Out[1109]=",ExpressionUUID->"ad03a59d-d84f-4d2d-8c8f-07c2bfa9d79c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Flamenco", "Subsection",
 CellChangeTimes->{{3.817032211286097*^9, 3.817032212093605*^9}, {
  3.817032378573657*^9, 3.817032387621009*^9}, {3.8170327685188713`*^9, 
  3.817032778054562*^9}, {3.817033040616753*^9, 3.817033041216345*^9}, {
  3.817033353994588*^9, 3.817033354810561*^9}, {3.817033859705962*^9, 
  3.817033863353582*^9}, {3.817034834420116*^9, 
  3.8170348381318808`*^9}},ExpressionUUID->"03801196-a9d4-4247-9605-\
fab9e1d03d4c"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"toOffsetArray", "[", 
  RowBox[{"scaleFromPattern", "[", "flamencoPattern", "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"toHilightArray", "[", 
  RowBox[{"scaleFromPattern", "[", "flamencoPattern", "]"}], "]"}]}], "Input",
 
 CellChangeTimes->{{3.817028711790824*^9, 3.8170287256226263`*^9}, {
   3.817029962536846*^9, 3.817029966628759*^9}, {3.817030319798869*^9, 
   3.817030323628125*^9}, {3.817030978624303*^9, 3.817031302918007*^9}, {
   3.8170315952692337`*^9, 3.8170315975571423`*^9}, {3.817031759917487*^9, 
   3.817031764364489*^9}, 3.817031811648944*^9, 3.817032191995288*^9, {
   3.8170323923495493`*^9, 3.817032398933139*^9}, {3.8170327829676943`*^9, 
   3.817032816120308*^9}, {3.817033044689179*^9, 3.817033050344488*^9}, {
   3.81703335984317*^9, 3.817033364291978*^9}, {3.817033882876059*^9, 
   3.817033884195074*^9}, {3.817034842484466*^9, 3.817034848724843*^9}},
 CellLabel->
  "In[1121]:=",ExpressionUUID->"fa839e95-8db9-4f37-9bd3-98d55d32b5fc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "X", ",", "2", ",", "X", ",", "3", ",", "X", ",", "6", ",", "X", 
   ",", "7", ",", "X", ",", "8", ",", "X", ",", "11", ",", "X", ",", "12", 
   ",", "X", ",", "14", ",", "X", ",", "15", ",", "X", ",", "18", ",", "X", 
   ",", "19", ",", "X"}], "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.8170320429540243`*^9, 3.81703240136798*^9, 3.8170328186337233`*^9, 
   3.817032901845224*^9, 3.8170330524292583`*^9, 3.817033175765851*^9, 
   3.817033366872793*^9, 3.8170338871655188`*^9, 3.8170339532517843`*^9, {
   3.8170348503175087`*^9, 3.817034860438809*^9}},
 CellLabel->
  "Out[1121]=",ExpressionUUID->"ae07c136-3244-4f89-9056-cc6b88335f8c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "DARK_RED", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",",
    "0", ",", "DARK_GREEN", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "DARK_RED", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
   "0", ",", "0", ",", "DARK_GREEN", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.817031218222529*^9, 3.817031241966859*^9}, {
   3.817031275439089*^9, 3.817031281446774*^9}, 3.8170315985099993`*^9, 
   3.8170316374105387`*^9, 3.817031731027363*^9, 3.817031766739743*^9, 
   3.8170320429540243`*^9, 3.81703240136798*^9, 3.8170328186337233`*^9, 
   3.817032901845224*^9, 3.8170330524292583`*^9, 3.817033175765851*^9, 
   3.817033366872793*^9, 3.8170338871655188`*^9, 3.8170339532517843`*^9, {
   3.8170348503175087`*^9, 3.817034860440933*^9}},
 CellLabel->
  "Out[1122]=",ExpressionUUID->"7a6f8163-d3ec-43cc-a3c1-6f9c4e1e7dab"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Viva La Musica", "Section",
 CellChangeTimes->{{3.8184042859281673`*^9, 
  3.818404288976424*^9}},ExpressionUUID->"a959c86f-bae0-4b66-bb2c-\
5bf02779e087"],

Cell["By Michael Praetorius.", "Text",
 CellChangeTimes->{{3.817550228811357*^9, 3.8175502421231194`*^9}, {
  3.8184042915117903`*^9, 
  3.8184042919685373`*^9}},ExpressionUUID->"d1da543a-896a-4944-849c-\
621be55f2671"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"vivaNotes", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
    "\"\<G5\>\"", ",", "\"\<C5\>\"", ",", " ", "\"\<B4\>\"", ",", " ", 
     "\"\<A4\>\"", ",", "\"\<G4\>\"", ",", "\"\<F#4\>\"", ",", "\"\<G4\>\"", 
     ",", " ", "\"\<F#4\>\"", ",", "\"\<B4\>\"", ",", "\"\<C5\>\"", ",", 
     "\"\<D5\>\"", ",", "\"\<C5\>\"", ",", "\"\<B4\>\"", ",", "\"\<A4\>\"", 
     ",", "\"\<B4\>\"", ",", "\"\<A4\>\"", ",", "\"\<G4\>\"", ",", 
     "\"\<G4\>\"", ",", "\"\<C4\>\"", ",", "\"\<D4\>\"", ",", "\"\<E4\>\"", 
     ",", "\"\<D4\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"spnToMIDI", "[", "vivaNotes", "]"}], "\[IndentingNewLine]", 
 RowBox[{"vivaDurations", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{
   "3", ",", "1", ",", "2", ",", "1", ",", "1", ",", "2", ",", "2", ",", "4", 
    ",", "3", ",", "1", ",", "2", ",", "1", ",", "1", ",", "2", ",", "2", ",",
     "4", ",", "2", ",", "4", ",", "2", ",", "2", ",", "2", ",", "4"}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"Length", "[", "vivaNotes", "]"}]}], "Input",
 CellChangeTimes->{{3.817550250476267*^9, 3.817550280171832*^9}, {
  3.8175504412798433`*^9, 3.817550571770536*^9}, {3.8175506052523727`*^9, 
  3.8175506790927677`*^9}, {3.817550713526559*^9, 3.8175508039675694`*^9}, {
  3.8175514143997593`*^9, 
  3.8175514170708714`*^9}},ExpressionUUID->"8f5c3268-adbd-4907-b697-\
0d602a38ed84"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "79", ",", "72", ",", "71", ",", "69", ",", "67", ",", "65", ",", "67", ",",
    "65", ",", "71", ",", "72", ",", "74", ",", "72", ",", "71", ",", "69", 
   ",", "71", ",", "69", ",", "67", ",", "67", ",", "60", ",", "62", ",", 
   "64", ",", "62"}], "}"}]], "Output",
 CellChangeTimes->{
  3.8175506035497913`*^9, {3.817550650858265*^9, 3.817550679825726*^9}, 
   3.8175507198888483`*^9, {3.817550764097337*^9, 3.817550804265436*^9}},
 CellLabel->
  "Out[268]=",ExpressionUUID->"bad82cac-9386-4fce-8d6c-09feb6628cfd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "3", ",", "1", ",", "2", ",", "1", ",", "1", ",", "2", ",", "2", ",", "4", 
   ",", "3", ",", "1", ",", "2", ",", "1", ",", "1", ",", "2", ",", "2", ",", 
   "4", ",", "2", ",", "4", ",", "2", ",", "2", ",", "2", ",", "4"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.8175506035497913`*^9, {3.817550650858265*^9, 3.817550679825726*^9}, 
   3.8175507198888483`*^9, {3.817550764097337*^9, 3.817550804266438*^9}},
 CellLabel->
  "Out[269]=",ExpressionUUID->"41bd41ef-2c4d-4b05-9316-7fc3a316a804"],

Cell[BoxData["22"], "Output",
 CellChangeTimes->{
  3.8175506035497913`*^9, {3.817550650858265*^9, 3.817550679825726*^9}, 
   3.8175507198888483`*^9, {3.817550764097337*^9, 3.81755080426737*^9}},
 CellLabel->
  "Out[270]=",ExpressionUUID->"73c4e97c-14f4-44a5-be0e-3c2321781502"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{808, 911},
WindowMargins->{{Automatic, 861}, {Automatic, 0}},
FrontEndVersion->"12.1 for Mac OS X x86 (64-bit) (June 19, 2020)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"dc902f2d-c9b2-460c-92a8-076ef495ce27"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 168, 3, 98, "Title",ExpressionUUID->"8aacb6be-e246-4e3a-a029-72b090992f38"],
Cell[751, 27, 202, 4, 30, "Input",ExpressionUUID->"0009aed5-f18f-48da-96c5-e34180cba819"],
Cell[CellGroupData[{
Cell[978, 35, 210, 4, 67, "Section",ExpressionUUID->"91db6aee-bcad-4fa8-aa61-cfbae2cd7061"],
Cell[1191, 41, 2718, 64, 199, "Input",ExpressionUUID->"91f6da45-8c2c-4d5f-a716-1a2fec30daee"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3946, 110, 161, 3, 67, "Section",ExpressionUUID->"fa860b7d-a912-454a-b9ad-71dce55d01bf"],
Cell[4110, 115, 620, 11, 30, "Input",ExpressionUUID->"25f79bc3-fef8-4070-ab07-800db8d75a2b"],
Cell[CellGroupData[{
Cell[4755, 130, 163, 3, 54, "Subsection",ExpressionUUID->"80fe7a99-0793-41f6-aeae-a49a3755a7f0"],
Cell[4921, 135, 2080, 50, 241, "Input",ExpressionUUID->"4cda0951-50ca-4fb0-8a19-e8ec6dca1948"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7038, 190, 197, 3, 54, "Subsection",ExpressionUUID->"41ba3d98-c2f6-4b91-840c-44b801fe611f"],
Cell[7238, 195, 2204, 47, 157, "Input",ExpressionUUID->"6802b626-e00b-4529-9230-5b83da9cbfd7"],
Cell[9445, 244, 992, 19, 94, "Input",ExpressionUUID->"9a6d4e29-8fa4-43fd-a606-992cfbdc33fe"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10486, 269, 178, 3, 67, "Section",ExpressionUUID->"4fa865f2-8f81-4e6c-8ef2-92406202d020"],
Cell[10667, 274, 220, 5, 35, "Text",ExpressionUUID->"3bb5ba84-ee50-40dd-aa8c-d392d17f178c"],
Cell[10890, 281, 2837, 70, 367, "Input",ExpressionUUID->"24d334d7-8b22-4b9a-a06a-c8f5782039f3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13764, 356, 202, 4, 67, "Section",ExpressionUUID->"a23b5cbd-cba5-4813-8cc5-56e3cd801c04"],
Cell[13969, 362, 235, 6, 35, "Text",ExpressionUUID->"00d4a45b-12a7-4d98-a42e-c894aaecdf5d"],
Cell[CellGroupData[{
Cell[14229, 372, 7743, 179, 1270, "Input",ExpressionUUID->"58bfbb3e-8a4f-4994-9ee0-5d22d284ff12"],
Cell[21975, 553, 8081, 152, 689, "Output",ExpressionUUID->"5c16fb40-1463-4a2a-97b5-37d08e7a33c5"]
}, Open  ]],
Cell[30071, 708, 404, 9, 30, "Input",ExpressionUUID->"b23b565a-df5c-4c1d-aea7-13e1b6e3c1b0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30512, 722, 162, 3, 67, "Section",ExpressionUUID->"855d44c0-b9cd-44c3-891b-d48523c698bd"],
Cell[30677, 727, 2262, 41, 346, "Input",ExpressionUUID->"85a6df87-d037-44bf-8b33-dc5626b848c0"],
Cell[32942, 770, 1149, 27, 73, "Input",ExpressionUUID->"58298d8f-afd7-4d6e-b080-273ded9370fb"],
Cell[CellGroupData[{
Cell[34116, 801, 203, 4, 54, "Subsection",ExpressionUUID->"1e23093c-32d3-48e6-b74e-0de935bdb6b4"],
Cell[CellGroupData[{
Cell[34344, 809, 672, 12, 52, "Input",ExpressionUUID->"8051f445-705c-4d86-a685-717f5668b38c"],
Cell[35019, 823, 638, 12, 34, "Output",ExpressionUUID->"dc9ae9ef-eb40-4839-8ea4-ec3686ade820"],
Cell[35660, 837, 685, 13, 56, "Output",ExpressionUUID->"fade1e82-c86e-4ac5-8e7e-126ab26e6d4b"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[36394, 856, 250, 4, 54, "Subsection",ExpressionUUID->"c9e115b3-8edb-4d15-b3f2-c32c1c5903f1"],
Cell[CellGroupData[{
Cell[36669, 864, 745, 13, 52, "Input",ExpressionUUID->"1ef9c121-eeb3-48cb-92e2-a5c3ea11960e"],
Cell[37417, 879, 661, 12, 34, "Output",ExpressionUUID->"a18ea909-fb87-490e-a5c4-365f73e356ec"],
Cell[38081, 893, 687, 12, 56, "Output",ExpressionUUID->"f09fc328-b84d-4820-a8d7-010c9e479324"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[38817, 911, 255, 4, 54, "Subsection",ExpressionUUID->"142d9c07-6ae9-4219-99ed-f7e41c8eb704"],
Cell[CellGroupData[{
Cell[39097, 919, 757, 14, 52, "Input",ExpressionUUID->"e4277149-6e57-43d2-b973-9875252c9deb"],
Cell[39857, 935, 442, 9, 34, "Output",ExpressionUUID->"ea839d41-067b-4b56-bae8-12db8e6b05bb"],
Cell[40302, 946, 489, 10, 56, "Output",ExpressionUUID->"5c90a20d-c325-4624-8fd3-1a7e4850f909"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40828, 961, 438, 9, 30, "Input",ExpressionUUID->"3382b813-8cf3-492e-a1f7-f49687a9f574"],
Cell[41269, 972, 658, 12, 34, "Output",ExpressionUUID->"7e18c076-65ab-4d2d-84f4-757e07bc422e"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[41976, 990, 256, 4, 54, "Subsection",ExpressionUUID->"376c6cab-4f73-4abb-b1c5-1113e505037f"],
Cell[CellGroupData[{
Cell[42257, 998, 753, 13, 52, "Input",ExpressionUUID->"4a0ad33c-ee24-4eaa-bc3e-fef46e3dcec8"],
Cell[43013, 1013, 655, 12, 34, "Output",ExpressionUUID->"db9c3d21-78ad-4db1-a910-5f7eec2e8196"],
Cell[43671, 1027, 679, 12, 56, "Output",ExpressionUUID->"0a59ec4f-ca93-486c-bf1c-c6c73ce9035e"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[44399, 1045, 261, 4, 54, "Subsection",ExpressionUUID->"7787aaa7-2f21-4433-bfb2-5b92f5da3752"],
Cell[CellGroupData[{
Cell[44685, 1053, 819, 15, 52, "Input",ExpressionUUID->"592dff2d-fe4b-425b-8d45-334e3d3d8cf3"],
Cell[45507, 1070, 710, 13, 34, "Output",ExpressionUUID->"2dcfc781-7611-46d9-b277-36f970275fbd"],
Cell[46220, 1085, 765, 14, 56, "Output",ExpressionUUID->"83c77a5d-ab7e-4053-8ab9-76cdce60a6d8"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[47034, 1105, 310, 5, 54, "Subsection",ExpressionUUID->"f10cbda5-a9ba-48cd-8988-84b9207dc79c"],
Cell[CellGroupData[{
Cell[47369, 1114, 865, 15, 52, "Input",ExpressionUUID->"ecedf9ad-f4ec-4898-863f-5e1ba891c4b4"],
Cell[48237, 1131, 757, 13, 34, "Output",ExpressionUUID->"d9d0eabf-9a49-410f-b12f-e021ea0081c3"],
Cell[48997, 1146, 789, 14, 56, "Output",ExpressionUUID->"481257ec-a883-4c38-a981-2c3a73ddad36"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[49835, 1166, 348, 6, 54, "Subsection",ExpressionUUID->"8f176a2a-927b-4240-b864-21d33a9aceb7"],
Cell[CellGroupData[{
Cell[50208, 1176, 892, 15, 52, "Input",ExpressionUUID->"22eb76a2-a5d6-438f-8800-5b7fa43a367c"],
Cell[51103, 1193, 782, 14, 34, "Output",ExpressionUUID->"14ef08a7-a8be-4213-be9b-776aded97d67"],
Cell[51888, 1209, 807, 14, 56, "Output",ExpressionUUID->"2eadc398-5dcc-40f9-a7ca-660eaab42f0a"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[52744, 1229, 405, 6, 54, "Subsection",ExpressionUUID->"02bf9110-4055-41ab-9892-c1ee4ba0e965"],
Cell[CellGroupData[{
Cell[53174, 1239, 964, 17, 52, "Input",ExpressionUUID->"11fc8d92-c878-4ec1-b99c-cc86fcfe513d"],
Cell[54141, 1258, 829, 14, 34, "Output",ExpressionUUID->"9c93a520-3d5d-4d14-b1b0-c7b347d1e19c"],
Cell[54973, 1274, 878, 15, 56, "Output",ExpressionUUID->"ad03a59d-d84f-4d2d-8c8f-07c2bfa9d79c"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[55900, 1295, 448, 7, 54, "Subsection",ExpressionUUID->"03801196-a9d4-4247-9605-fab9e1d03d4c"],
Cell[CellGroupData[{
Cell[56373, 1306, 996, 17, 52, "Input",ExpressionUUID->"fa839e95-8db9-4f37-9bd3-98d55d32b5fc"],
Cell[57372, 1325, 881, 15, 34, "Output",ExpressionUUID->"ae07c136-3244-4f89-9056-cc6b88335f8c"],
Cell[58256, 1342, 907, 15, 56, "Output",ExpressionUUID->"7a6f8163-d3ec-43cc-a3c1-6f9c4e1e7dab"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[59224, 1364, 161, 3, 67, "Section",ExpressionUUID->"a959c86f-bae0-4b66-bb2c-5bf02779e087"],
Cell[59388, 1369, 219, 4, 35, "Text",ExpressionUUID->"d1da543a-896a-4944-849c-621be55f2671"],
Cell[CellGroupData[{
Cell[59632, 1377, 1399, 26, 115, "Input",ExpressionUUID->"8f5c3268-adbd-4907-b697-0d602a38ed84"],
Cell[61034, 1405, 560, 11, 34, "Output",ExpressionUUID->"bad82cac-9386-4fce-8d6c-09feb6628cfd"],
Cell[61597, 1418, 537, 11, 34, "Output",ExpressionUUID->"41bd41ef-2c4d-4b05-9316-7fc3a316a804"],
Cell[62137, 1431, 278, 5, 34, "Output",ExpressionUUID->"73c4e97c-14f4-44a5-be0e-3c2321781502"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

